###############################################################
##Script to create the shape for cut rasters for train maxent##
###############################################################

#Load the following libraries
library(adehabitatHR)
library(raster)
library(rgdal)
library(virtualspecies)

##Load presence data
huemuldata<-read.csv("F:/Documents/huemul.csv",h=T)

##Remove first column
hp<-(huemuldata[,c(-1)])#para remover columnas

#Convert to SpatialPoints datatype
hp<-SpatialPoints(coords=hp)
plot(hp)

#Calcutale Utilization Distribution for huemul
huemulk<- kernelUD(hp, h="href")

#Convert to raster
huemulv <- getvolumeUD(huemulk)
image(huemulv)

#Save to shapefile
border<- getverticeshr(huemulv,95)
plot(border)
rgdal::writeOGR(obj=border,dsn="border",layer="border",driver="ESRI Shapefile")

###############################################################
###Cut raster with a shapefile and do a correlation analysis###
###############################################################

setwd("F:/Documents/raster/asc")

#Load raster data from WorldClim database

bio1<-raster("bio1.asc")
bio2<-raster("bio2.asc")
bio3<-raster("bio3.asc")
bio4<-raster("bio4.asc")
bio5<-raster("bio5.asc")
bio6<-raster("bio6.asc")
bio7<-raster("bio7.asc")
bio8<-raster("bio8.asc")
bio9<-raster("bio9.asc")
bio10<-raster("bio10.asc")
bio11<-raster("bio11.asc")
bio12<-raster("bio12.asc")
bio13<-raster("bio13.asc")
bio14<-raster("bio14.asc")
bio15<-raster("bio15.asc")
bio16<-raster("bio16.asc")
bio17<-raster("bio17.asc")
bio18<-raster("bio18.asc")
bio19<-raster("bio19.asc")
alt<-raster("alt.asc")

#Cut rasters

altc<-mask(crop(alt,border),border)
bio1c<-mask(crop(bio1,border),border)
bio2c<-mask(crop(bio2,border),border)
bio3c<-mask(crop(bio3,border),border)
bio4c<-mask(crop(bio4,border),border)
bio5c<-mask(crop(bio5,border),border)
bio6c<-mask(crop(bio6,border),border)
bio7c<-mask(crop(bio7,border),border)
bio8c<-mask(crop(bio8,border),border)
bio9c<-mask(crop(bio9,border),border)
bio10c<-mask(crop(bio10,border),border)
bio11c<-mask(crop(bio11,border),border)
bio12c<-mask(crop(bio12,border),border)
bio13c<-mask(crop(bio13,border),border)
bio14c<-mask(crop(bio14,border),border)
bio15c<-mask(crop(bio15,border),border)
bio16c<-mask(crop(bio16,border),border)
bio17c<-mask(crop(bio17,border),border)
bio18c<-mask(crop(bio18,border),border)
bio19c<-mask(crop(bio19,border),border)


#Stack rasters for correlation analysis
rasterstack<- stack(altc,bio1c,bio2c,bio3c,bio4c,bio5c,bio6c,bio7c,bio8c,bio9c,bio10c,bio11c,bio12c,
                bio13c,bio14c,bio15c,bio16c,bio17c,bio18c,bio19c)

rastersreduced <- removeCollinearity(rasterstack, multicollinearity.cutoff = 0.85,
                                           select.variables = TRUE, sample.points = FALSE, plot = TRUE)
rastersreduced

##write rasters
writeRaster(altc,"alt.asc",overwrite=TRUE)
writeRaster(bio1c,"bio1.asc",overwrite=TRUE)
writeRaster(bio3c,"bio3.asc",overwrite=TRUE)
writeRaster(bio4c,"bio4.asc",overwrite=TRUE)
writeRaster(bio6c,"bio6.asc",overwrite=TRUE)
writeRaster(bio7c,"bio7.asc",overwrite=TRUE)
writeRaster(bio8c,"bio8.asc",overwrite=TRUE)
writeRaster(bio9c,"bio9.asc",overwrite=TRUE)
writeRaster(bio12c,"bio12.asc",overwrite=TRUE)
writeRaster(bio15c,"bio15.asc",overwrite=TRUE)
writeRaster(bio19c,"bio19.asc",overwrite=TRUE)

